#!/bin/bash

strip_whitespace()
{
	COUNT=0
	while read FILE; do
		echo "Stripping whitespaces from: $FILE"
		sed -i -r -e 's|[ \t]+$||' $FILE
		((COUNT++))
	done
	echo "Stripped whitespaces from $COUNT files."
}

if [ "$1" = '--all' ]; then
	find ./src -type f -regex '.*\.[ch]' \
	| xargs -d '\n' egrep -l '[[:space:]]+$' \
	| strip_whitespace
elif [ -f "$1" ]; then
	echo "$1" | strip_whitespace
else
	echo "Usage: $0 FILENAME | --all"
fi
